//+------------------------------------------------------------------+
//|                                                     LotSizer.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//--- input parameters
extern int       move=5;
extern int       TP=30;
extern int       SL=45;
extern int       HG=15;
extern double    startLot=0.1;
bool             tradeOpen=true;
bool             hedgeCreated=false;
double              MPrice=0;
double           LHedge,longStop,longTake;
double           SHedge,shortStop,shortTake;
int              ticket;
double           nextLot;
string           nextPos,err;
bool             calcd=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   Print("started");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
   if (tradeOpen)
   {
      if (MPrice == 0)
      { 
        MPrice = Ask;
        Print("Mrice ",MPrice);
      }
      if (!calcd)
      {
        LHedge = MPrice + (move*Point*10);
        SHedge = MPrice - (move*Point*10);
        longStop = LHedge -(SL*Point*10);
        longTake = LHedge +(TP*Point*10);
        shortStop = SHedge +(SL*Point*10);
        shortTake = SHedge -(TP*Point*10);
        
        Print(move*Point*10);
        Print(LHedge,"|",SHedge);
        Print(longStop,"|",longTake);
        Print(shortStop,"|",shortTake);
        calcd=true;
      }
      
      if (!hedgeCreated)
      {
         if (Ask >= LHedge)
         {
            ticket=OrderSend(Symbol(),OP_BUY,startLot,LHedge,3,longStop,longTake);
            if (ticket>0) Print("Hedge long at ",LHedge," ",longStop," ",longTake);
            else { err=StringConcatenate("Hedge long failed:",GetLastError(),"|",LHedge,"|stop:",longStop,"|Take:",longTake); Print(err); }
            nextLot=startLot*3;
            ticket=OrderSend(Symbol(),OP_SELLSTOP,nextLot,SHedge,3,shortStop,shortTake);
            if (ticket>0) Print("Hedge short at ",SHedge," ",shortStop," ",shortTake);
            else { err=StringConcatenate("Pending Hedge short failed:",GetLastError(),"|",SHedge,"|stop:",shortStop,"|Take:",shortTake); Print(err); }
            nextLot*=2;
            hedgeCreated=true;
            nextPos="short";
         }
                     
         if (Bid <= SHedge)
         {
            OrderSend(Symbol(),OP_SELL,startLot,SHedge,3,shortStop,shortTake);
            if (ticket>0) Print("Hedge short at ",SHedge," ",shortStop," ",shortTake);
            else Print("Hedge short failed:",GetLastError());
            nextLot=startLot*3;
            OrderSend(Symbol(),OP_BUYLIMIT,nextLot,LHedge,3,longStop,longTake);
            if (ticket>0) Print("Hedge long at ",LHedge," ",longStop," ",longTake);
            else { err=StringConcatenate("Pending Hedge long failed:",GetLastError(),"|",LHedge,"|stop:",longStop,"|Take:",longTake); Print(err); }
            nextLot*=2;
            hedgeCreated=true;
            nextPos="long";
         }
      }
      
      if (hedgeCreated)
      {
         if ((nextPos=="short") && (Bid <= SHedge))
         {
            ticket=OrderSend(Symbol(),OP_BUYSTOP,nextLot,LHedge,3,longStop,longTake);
            if (ticket>0) Print("Created LHedge ",LHedge," ",nextLot," lots");
            else { err=StringConcatenate("New Hedge long failed:",GetLastError(),"|",LHedge,"|stop:",longStop,"|Take:",longTake); Print(err); }
            nextLot*=2;
            nextPos="long";
         }
         
         if ((nextPos=="long") && (Ask >= LHedge))
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,nextLot,SHedge,3,shortStop,shortTake);
            if (ticket>0) Print("Created LHedge ",SHedge," ",nextLot," lots");
            else { err=StringConcatenate("New Hedge short failed:",GetLastError(),"|",SHedge,"|stop:",shortStop,"|Take:",shortTake); Print(err); }
            nextLot*=2;
            nextPos="short";
         }
         
      }
         
      if ((Ask>=shortStop) || (Ask<=shortTake) || (Bid >=longTake) || (Bid <=longStop))
      {
         tradeOpen=false;
         Print("Trade Closed");
         //return(0);
      }     
       
   
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+